%define full_name jakarta-%{name}
%define full_jname jasper55
%define jname jasper
%define majversion 5.5
%define servletspec 2.4
%define jspspec 2.0
%define section devel

%define tcuid 93

%define packname jakarta-tomcat-%{version}
%define packdname jakarta-tomcat-%{version}-src

# FHS 2.2 compliant tree structure
# see http://www.pathname.com/fhs/2.2/
%define confdir %{_sysconfdir}/%{name}
%define logdir %{_localstatedir}/log/%{name}
%define homedir %{_datadir}/%{name}
%define bindir %{_datadir}/%{name}/bin
%define tempdir %{_localstatedir}/cache/%{name}/temp
%define workdir %{_localstatedir}/cache/%{name}/work
%define appdir %{_localstatedir}/lib/%{name}/webapps
%define serverdir %{_localstatedir}/lib/%{name}/server
%define commondir %{_localstatedir}/lib/%{name}/common
%define shareddir %{_localstatedir}/lib/%{name}/shared

Summary: Apache Servlet/JSP Engine, RI for Servlet 2.4/JSP 2.0 API
Name: tomcat55
Version: 5.5.9
Release: 4jpp.3AX
Epoch: 0
License: Apache Software License
Group: Networking/Daemons
URL: http://jakarta.apache.org/tomcat/
BuildArch: noarch
Source0: http://jakarta.apache.org/builds/jakarta-tomcat-5.5/release/v%{version}/src/%{packdname}.tar.gz
Source1: %{name}-%{majversion}.init
Source2: %{name}-%{majversion}.conf
Source3: %{name}-%{majversion}.wrapper
Source4: %{name}-%{majversion}.logrotate
Source5: %{name}-%{majversion}.relink
Source6: http://archive.apache.org/dist/jakarta/commons/collections/source/commons-collections-3.1-src.tar.gz
Source7: http://archive.apache.org/dist/jakarta/commons/pool/source/commons-pool-1.2-src.tar.gz
Source8: http://archive.apache.org/dist/jakarta/commons/dbcp/source/commons-dbcp-1.2.1-src.tar.gz

Patch0: %{name}-%{majversion}.link_admin_jar.patch
Patch1: %{name}-%{version}-skip-build-on-install.patch
Patch2: %{name}-%{version}-jt5-build.patch
Patch3: %{name}-%{version}-jtc-build.patch
Patch4: %{name}-%{version}-jtj-build.patch
Patch5: %{name}-%{version}-javaxssl.patch
Patch6: %{name}-%{version}-bootstrap.MF.patch
Patch7: %{name}-%{version}-catalina.sh.patch
Patch8: %{name}-%{version}-jasper.sh.patch
Patch9: %{name}-%{version}-jspc.sh.patch
Patch10: %{name}-%{version}-setclasspath.sh.patch
BuildRoot: %{_tmppath}/%{name}-%{epoch}-%{version}-%{release}-root

Requires: jpackage-utils >= 0:1.6.0
Requires: ant >= 0:1.6.2
Requires: eclipse-ecj >= 0:3.0.1
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-%{jname} = %{epoch}:%{version}-%{release}
# xml parsing packages
Requires: xerces-j2 >= 0:2.6.2
Requires: xml-commons-apis
Requires: regexp >= 0:1.3
#Requires: tyrex >= 0:1.0
# jakarta-commons packages
Requires: jakarta-commons-beanutils >= 0:1.7.0
Requires: jakarta-commons-collections >= 0:3.1
Requires: jakarta-commons-daemon
Requires: jakarta-commons-dbcp >= 0:1.2.1
Requires: jakarta-commons-digester >= 0:1.6
Requires: jakarta-commons-el >= 0:1.0
Requires: jakarta-commons-fileupload >= 0:1.0-1jpp
Requires: jakarta-commons-modeler
Requires: jakarta-commons-pool >= 0:1.2
Requires: jakarta-commons-logging >= 0:1.0.4
Requires: jakarta-commons-launcher >= 0:0.9
Requires: mx4j >= 0:2.0.1
# alternatives
# Drop Requires: jaas
# Drop Requires: jndi
# Drop Requires: jndi-ldap
# Drop Requires: jdbc-stdext
# formerly non-free stuff
# geronimo-specs replaces non-free jta
#Requires: geronimo-specs
# jaf can be provided by classpathx-jaf
#Requires: jaf >= 0:1.0.1
# javamail can be provided by classpathx-mail
#Requires: javamail >= 0:1.3

Buildrequires: jpackage-utils >= 0:1.6.0
BuildRequires: ant >= 0:1.6.2
BuildRequires: eclipse-ecj >= 0:3.0.1
BuildRequires: ant-trax
BuildRequires: xalan-j2
BuildRequires: jakarta-commons-beanutils
BuildRequires: jakarta-commons-collections >= 0:2.0
BuildRequires: jakarta-commons-daemon
BuildRequires: jakarta-commons-dbcp >= 0:1.2.1
BuildRequires: jakarta-commons-digester >= 0:1.6
BuildRequires: jakarta-commons-logging >= 0:1.0.4
BuildRequires: jakarta-commons-fileupload >= 0:1.0
BuildRequires: jakarta-commons-modeler
BuildRequires: jakarta-commons-pool >= 0:1.1
BuildRequires: jakarta-commons-launcher >= 0:0.9
BuildRequires: jakarta-commons-el >= 0:1.0
# Drop BuildRequires: jaas
# Drop BuildRequires: jdbc-stdext >= 0:2.0
# Drop BuildRequires: jndi >= 0:1.2.1
# Drop BuildRequires: jndi-ldap
# Drop BuildRequires: jsse >= 0:1.0.2
BuildRequires: junit >= 0:3.8.1
BuildRequires: mx4j >= 0:2.0.1
BuildRequires: regexp >= 0:1.3
BuildRequires: struts >= 0:1.1
#BuildRequires: tyrex >= 0:1.0
BuildRequires: xerces-j2 >= 0:2.6.2
BuildRequires: xml-commons-apis
BuildRequires: jakarta-taglibs-standard >= 0:1.1.0
# formerly non-free stuff
# geronimo-specs replaces non-free jta
#BuildRequires: geronimo-specs
# jaf can be provided by classpathx-jaf
#BuildRequires: jaf >= 0:1.0.1
# javamail can be provided by classpathx-mail
#BuildRequires: javamail >= 0:1.3

%description
Tomcat is the servlet container that is used in the official Reference
Implementation for the Java Servlet and JavaServer Pages technologies.
The Java Servlet and JavaServer Pages specifications are developed by
Sun under the Java Community Process.

Tomcat is developed in an open and participatory environment and
released under the Apache Software License. Tomcat is intended to be
a collaboration of the best-of-breed developers from around the world.
We invite you to participate in this open development project. To
learn more about getting involved, click here.

%package webapps
Group: System Environment/Applications
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: jakarta-taglibs-standard >= 0:1.1.0
Summary: Web applications for Jakarta Tomcat

%description webapps
Web applications for Jakarta Tomcat

%package admin-webapps
Group: System Environment/Applications
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: struts >= 0:1.1
Summary: The administrative web applications for Jakarta Tomcat

%description admin-webapps
The administrative web applications (admin and manager) for Jakarta Tomcat

%package servlet-%{servletspec}-api
Group: Internet/WWW/Dynamic Content
Requires: /usr/sbin/update-alternatives
Summary: Jakarta Tomcat Servlet and JSP implementation classes
Obsoletes: servletapi5
Provides: servlet
Provides: servlet5
Provides: servlet24
Provides: servletapi5

%description servlet-%{servletspec}-api
Contains the source code for the implementation classes
of the Jakarta Tomcat Servlet and JSP APIs (packages javax.servlet).

%package servlet-%{servletspec}-api-javadoc
Group: Development/Documentation
Summary: Javadoc generated documentation for %{name}-servlet-%{servletspec}-api
Obsoletes: servletapi5-javadoc

%description servlet-%{servletspec}-api-javadoc
Contains the javadoc generated documentation for the implementation classes
of the Jakarta Tomcat Servlet and JSP APIs (packages javax.servlet).

%package %{jname}
Group: Development/Compilers
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Summary: Compiler JARs and associated scripts for %{name}

%description %{jname}
Compiler JARs and associated scripts for %{name}

%package %{jname}-javadoc
Group: Development/Documentation
Summary: Javadoc generated documentation for %{name}-%{jname}

%description %{jname}-javadoc
Javadoc for generated documentation %{name}-%{jname}

%prep
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%setup -q -c -T -a 0 
cp %{SOURCE6} .
cp %{SOURCE7} .
cp %{SOURCE8} .

cd %{packdname}
%patch0 -p2
%patch1 -p2
%patch2 -p0 -b .sav
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p0 -b .sav
%patch8 -p1
%patch9 -p1
%patch10 -p1

%build
export CLASSPATH=%(build-classpath xml-commons-apis xalan-j2)

# Remove pre-built jars
for j in $(find $RPM_BUILD_DIR/%{name}-%{version}/%{packdname} -name "*.jar") ; do
    echo removed $j
    mv $j $j.no
done

pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}
    cp jakarta-tomcat-5/LICENSE .
popd 

# build jspapi and servletapi as ant dist will require them later
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-servletapi-5
    pushd jsr154
        ant -Dservletapi.build=build \
            -Dservletapi.dist=dist \
            -Dbuild.compiler=modern dist
    popd
    pushd jsr152
        ant -Dservletapi.build=build \
            -Dservletapi.dist=dist \
            -Dbuild.compiler=modern dist
    popd
popd

# build jasper subpackage
CLASSPATH=%(build-classpath xml-commons-apis xalan-j2)
export CLASSPATH=$CLASSPATH:$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-servletapi-5/jsr154/dist/lib/servlet-api.jar
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-%{jname}/jasper2
    cat > build.properties <<EOBP
ant.jar=$(build-classpath ant)
servlet-api.jar=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-servletapi-5/jsr154/dist/lib/servlet-api.jar
jsp-api.jar=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-servletapi-5/jsr152/dist/lib/jsp-api.jar
tools.jar=%{java.home}/lib/tools.jar
xerces.jar=$(build-classpath xerces-j2)
xercesImpl.jar=$(build-classpath jaxp_parser_impl)
xmlParserAPIs.jar=$(build-classpath xml-commons-apis)
commons-el.jar=$(build-classpath commons-el)
commons-collections.jar=$(build-classpath commons-collections)
commons-logging.jar=$(build-classpath commons-logging)
commons-daemon.jar=$(build-classpath commons-daemon)
junit.jar=$(build-classpath junit)
EOBP
    # can't use jikes to build tomcat4 (strange)
    ant -Djava.home=%{java_home} -Dbuild.compiler=modern javadoc
popd

# build tomcat 55
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-5
    cat >> build.properties << EOBP
ant.jar=%{_javadir}/ant.jar
ant-launcher.jar=%{_javadir}/ant.jar
jtc.home=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-connectors/
%{jname}.home=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-%{jname}/jasper2
commons-beanutils.jar=$(build-classpath commons-beanutils)
commons-fileupload.jar=$(build-classpath commons-fileupload)
commons-collections.jar=$(build-classpath commons-collections)
commons-daemon.jar=$(build-classpath commons-daemon)
commons-dbcp.jar=$(build-classpath commons-dbcp)
commons-digester.jar=$(build-classpath commons-digester)
commons-el.jar=$(build-classpath commons-el)
commons-launcher.jar=$(build-classpath commons-launcher)
commons-logging.jar=$(build-classpath commons-logging)
commons-logging-api.jar=$(build-classpath commons-logging-api)
commons-modeler.jar=$(build-classpath commons-modeler)
commons-pool.jar=$(build-classpath commons-pool)
jmx.jar=$(build-classpath mx4j/mx4j-jmx)
jmx-tools.jar=$(build-classpath mx4j/mx4j-tools)
jmxri.jar=$(build-classpath mx4j/mx4j-jmx)
junit.jar=$(build-classpath junit)
regexp.jar=$(build-classpath regexp)
servlet-api.jar=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-servletapi-5/jsr154/dist/lib/servlet-api.jar
jsp-api.jar=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-servletapi-5/jsr152/dist/lib/jsp-api.jar
servlet.doc=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-servletapi-5/jsr154/dist/docs/api
xercesImpl.jar=$(build-classpath jaxp_parser_impl)
xml-apis.jar=$(build-classpath xml-commons-apis)
struts.jar=$(build-classpath struts)
struts.lib=%{_datadir}/struts
servletapi.build.notrequired=true
jspapi.build.notrequired=true
commons-collections.home=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-5/tomcat-deps/commons-collections-3.1
commons-pool.home=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-5/tomcat-deps/commons-pool-1.2
commons-dbcp.home=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-5/tomcat-deps/commons-dbcp-1.2.1
jdt.home=%{_datadir}/eclipse/plugins/org.eclipse.jdt.core_3.0.1
commons-dbcp-src.loc=file:$RPM_BUILD_DIR/%{name}-%{version}/commons-dbcp-1.2.1-src.tar.gz
commons-pool-src.loc=file:$RPM_BUILD_DIR/%{name}-%{version}/commons-pool-1.2-src.tar.gz
commons-collections-src.loc=file:$RPM_BUILD_DIR/%{name}-%{version}/commons-collections-3.1-src.tar.gz
EOBP
#activation.jar=$(build-classpath jaf)
#mail.jar=$(build-classpath javamail/mailapi)
#jta.jar=$(build-classpath geronimo/spec-jta-1.0.1B)
#tyrex.jar=$(build-classpath tyrex)
mkdir -p tomcat-deps/commons-collections-3.1
mkdir -p tomcat-deps/commons-pool-1.2
mkdir -p tomcat-deps/commons-dbcp-1.2.1
# can't use jikes to build tomcat4 (strange)
    ant -Dbuild.compiler=modern -Djava.home=%{java_home} build-depends build
popd

# build the connectors
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-connectors
# use the JARs created above to build
    export CLASSPATH=$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-servletapi-5/jsr154/dist/lib/servlet-api.jar:$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-5/build/server/lib/catalina.jar
    cat > build.properties << EOBP
ant.jar=%{_javadir}/ant.jar
junit.jar=$(build-classpath junit)
commons-beanutils.jar=$(build-classpath commons-beanutils)
commons-collections.jar=$(build-classpath commons-collections)
commons-daemon.jar=$(build-classpath commons-daemon)
commons-digester.jar=$(build-classpath commons-digester)
commons-fileupload.jar=$(build-classpath commons-fileupload)
commons-logging.jar=$(build-classpath commons-logging)
commons-logging-api.jar=$(build-classpath commons-logging-api)
commons-modeler.jar=$(build-classpath commons-modeler)
commons-pool.jar=$(build-classpath commons-pool)
jmx.jar=$(build-classpath mx4j/mx4j-jmx)
regexp.jar=$(build-classpath regexp)
EOBP
#activation.jar=$(build-classpath jaf)
#mail.jar=$(build-classpath javamail/mailapi)
#jta.jar=$(build-classpath geronimo/spec-jta-1.0.1B)
#tyrex.jar=$(build-classpath tyrex)
    ant -Dbuild.compiler=modern -Djava.home=%{java_home} build
popd

%install
rm -rf $RPM_BUILD_ROOT
CLASSPATH=%(build-classpath xalan-j2 xml-commons-apis jakarta-taglibs-core jakarta-taglibs-standard)
export CLASSPATH=$CLASSPATH:$RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-servletapi-5/jsr152/dist/lib/jsp-api.jar
# build initial path structure
install -d -m 755 $RPM_BUILD_ROOT/{%{confdir},%{logdir},%{homedir},%{bindir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{serverdir},%{tempdir},%{workdir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{appdir},%{commondir},%{shareddir}}
install -d -m 755 $RPM_BUILD_ROOT/%{_sysconfdir}/{init.d,logrotate.d}
install -d -m 755 $RPM_BUILD_ROOT/{%{_bindir},%{_javadir}}
install -m 755 %{SOURCE5} $RPM_BUILD_ROOT/%{bindir}/relink
# SysV init and configuration
install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name}
install %{SOURCE2} $RPM_BUILD_ROOT/%{confdir}/%{name}.conf
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-5
    export usejikes=false
    ant -Dbuild.compiler=modern -Djava.home=%{java_home} dist
    pushd dist
        mv bin/* $RPM_BUILD_ROOT%{bindir}
        mv common/* $RPM_BUILD_ROOT%{commondir}
        mv conf/* $RPM_BUILD_ROOT%{confdir}
        mv server/* $RPM_BUILD_ROOT%{serverdir}
        mv shared/* $RPM_BUILD_ROOT%{shareddir}
        mv webapps/* $RPM_BUILD_ROOT%{appdir}
    popd
popd
# create reloctomcat55 (is this really necessary anymore?)
cat >> $RPM_BUILD_ROOT%{bindir}/reloctomcat55 << EORLTC
#!/bin/sh
#

echo "relocating http & ajp ports to 81xx"

sed -e 's;8080;8180;' \
    -e 's;8081;8181;' \
    -e 's;8082;8182;' \
    -e 's;8443;8543;' \
    -e 's;8009;8109;' \
    %{confdir}/server.xml > %{confdir}/server.xml.reloc

mv %{confdir}/server.xml %{confdir}/server.xml.bak
cp %{confdir}/server.xml.reloc %{confdir}/server.xml

EORLTC
# rename catalina.sh into dtomcat55 to let wrapper take precedence
install $RPM_BUILD_ROOT%{bindir}/catalina.sh \
    $RPM_BUILD_ROOT%{_bindir}/d%{name}
rm -f $RPM_BUILD_ROOT%{bindir}/catalina.sh.*
# Remove leftover files
rm -f $RPM_BUILD_ROOT%{bindir}/*.orig
# install wrapper as tomcat55
install %{SOURCE3} $RPM_BUILD_ROOT%{_bindir}/%{name}
# install logrotate support
install %{SOURCE4} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}
# remove / reorder non-usefull stuff
rm -rf $RPM_BUILD_ROOT%{homedir}/src/
rm -f  $RPM_BUILD_ROOT%{bindir}/*.sh $RPM_BUILD_ROOT%{bindir}/*.bat
# FHS compliance patches, not easy to track them all boys :)
for i in $RPM_BUILD_ROOT%{confdir}/%{name}.conf \
         $RPM_BUILD_ROOT%{_bindir}/d%{name} \
         $RPM_BUILD_ROOT%{_bindir}/%{name} \
         $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name} \
         $RPM_BUILD_ROOT%{bindir}/relink \
         $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/%{name}; do
    perl -pi -e "s|\@\@\@TCCONF\@\@\@|%{confdir}|g;" $i
    perl -pi -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g;" $i
    perl -pi -e "s|\@\@\@TCBIN\@\@\@|%{bindir}|g;" $i
    perl -pi -e "s|\@\@\@TCCOMMON\@\@\@|%{commondir}|g;" $i
    perl -pi -e "s|\@\@\@TCSERVER\@\@\@|%{serverdir}|g;" $i
    perl -pi -e "s|\@\@\@TCSHARED\@\@\@|%{shareddir}|g;" $i
    perl -pi -e "s|\@\@\@TCAPP\@\@\@|%{appdir}|g;" $i
    perl -pi -e "s|\@\@\@TCLOG\@\@\@|%{logdir}|g;" $i
done
# Remove local JARs (to be replaced with jpp links in post)
pushd $RPM_BUILD_ROOT/%{serverdir}/lib
    find . -name "*.jar" -not -name "catalina*" \
                         -not -name "servlets-*" \
                         -not -name "tomcat-*" | xargs -t rm -f
    # catalina-ant will be installed in a public repository
    mv catalina-ant.jar $RPM_BUILD_ROOT/%{_javadir}/catalina-ant-%{version}.jar
    pushd $RPM_BUILD_ROOT/%{_javadir}
        ln -fs catalina-ant-%{version}.jar catalina-ant55.jar
    popd
popd
# Process admin webapp server/webapps/admin
pushd $RPM_BUILD_ROOT/%{serverdir}/webapps/admin/WEB-INF/lib
    find . -name "*.jar" -not -name 'catalina-admin*' | xargs -t rm -f
popd
# Process common/lib
pushd $RPM_BUILD_ROOT/%{commondir}/lib
    find . -name "*.jar" -not -name "%{jname}*" \
                         -not -name "naming*" | xargs -t rm -f
    # jasper's jars will be installed in a public repository
    for i in %{jname}-compiler %{jname}-compiler-jdt %{jname}-runtime; do
        j=`echo $i | sed 's:%{jname}-:%{jname}55-:'`
        mv $i.jar $RPM_BUILD_ROOT%{_javadir}/$j-%{version}.jar
        pushd $RPM_BUILD_ROOT%{_javadir}
            ln -sf $j-%{version}.jar $j.jar
        popd
    done
popd
# Process common/endorsed
pushd $RPM_BUILD_ROOT/%{commondir}/endorsed
    find . -name "*.jar" | xargs -t rm -f
popd
# avoid duplicate servlet.jar
rm -f $RPM_BUILD_ROOT%{commondir}/lib/servlet.jar
# Perform FHS translation
# (final links)
pushd $RPM_BUILD_ROOT%{homedir}
    [ -d bin ] || ln -fs %{bindir} bin
    [ -d common ] || ln -fs %{commondir} common
    [ -d conf ] || ln -fs %{confdir} conf
    [ -d logs ] || ln -fs %{logdir} logs
    [ -d server ] || ln -fs %{serverdir} server
    [ -d shared ] || ln -fs %{shareddir} shared
    [ -d webapps ] || ln -fs %{appdir} webapps
    [ -d work ] || ln -fs %{workdir} work
    [ -d temp ] || ln -fs %{tempdir} temp
popd
cd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}
find $RPM_BUILD_ROOT%{homedir} -type l -maxdepth 1 | \
    sed s+$RPM_BUILD_ROOT++g > homelinks
# begin servletapi subpackage install
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-servletapi-5
    install -m 644 jsr152/dist/lib/jsp-api.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-jsp-%{jspspec}-api-%{version}.jar
    install -m 644 jsr154/dist/lib/servlet-api.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-servlet-%{servletspec}-api-%{version}.jar
    pushd $RPM_BUILD_ROOT%{_javadir}
        ln -sf %{name}-jsp-%{jspspec}-api-%{version}.jar \
            %{name}-jsp-%{jspspec}-api.jar
        ln -sf %{name}-servlet-%{servletspec}-api-%{version}.jar \
            %{name}-servlet-%{servletspec}-api.jar
    popd
    # javadoc jsp
    install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-jsp-%{jspspec}-api-%{version}
    cp -pr jsr152/build/docs/api/* \
        $RPM_BUILD_ROOT%{_javadocdir}/%{name}-jsp-%{jspspec}-api-%{version}
    # ghost symlink
    ln -s %{name}-jsp-%{jspspec}-api-%{version} \
        $RPM_BUILD_ROOT%{_javadocdir}/%{name}-jsp-%{jspspec}-api
    # javadoc servlet
    install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-servlet-%{servletspec}-api-%{version}
    cp -pr jsr154/build/docs/api/* \
        $RPM_BUILD_ROOT%{_javadocdir}/%{name}-servlet-%{servletspec}-api-%{version}
    # ghost symlink
    ln -s %{name}-servlet-%{servletspec}-api-%{version} \
        $RPM_BUILD_ROOT%{_javadocdir}/%{name}-servlet-%{servletspec}-api
popd
# begin jasper subpackage install
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-%{jname}
    install -m755 jasper2/src/bin/jspc.sh \
        $RPM_BUILD_ROOT%{_bindir}/jspc55.sh
    install -m755 jasper2/src/bin/%{jname}.sh \
        $RPM_BUILD_ROOT%{_bindir}/%{full_jname}.sh
popd
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-catalina
    install -m755 catalina/src/bin/setclasspath.sh \
        $RPM_BUILD_ROOT%{_bindir}/%{full_jname}-setclasspath.sh
popd
# javadoc
install -d -m755 $RPM_BUILD_ROOT%{_javadocdir}/%{jname}-%{version}
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-%{jname}
    cp -pr jasper2/build/javadoc/* \
        $RPM_BUILD_ROOT%{_javadocdir}/%{jname}-%{version}
    # ghost symlink
    ln -s %{jname}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{jname}
popd

%clean
rm -rf $RPM_BUILD_ROOT

%post
# install tomcat55 (but don't activate)
/sbin/chkconfig --add %{name}
# Create automated links - since all needed extensions may not have been
# installed for this jvm output is muted
# Try to set a sensible jvm
export JAVA_HOME=/usr/lib/jdk
export JVM_LIBDIR=/usr/lib/jdk-exports
# Remove old automated symlinks
for repository in %{serverdir}/lib \
                  %{commondir}/lib \
                  %{commondir}/endorsed ; do
    find $repository -name '\[*\]*.jar' -not -type d | xargs rm -f
done
build-jar-repository %{serverdir}/lib catalina-ant55 commons-beanutils \
                                      commons-digester commons-el \
                                      commons-fileupload commons-logging \
                                      commons-modeler log4j \
                                      jdtcore jdtCompilerAdapter \
                                      regexp 2>&1
build-jar-repository %{commondir}/lib ant commons-collections commons-dbcp \
                                      commons-el commons-logging-api \
                                      commons-pool \
                                      jsp log4j \
                                      servlet %{jname}55-compiler \
                                      jdtcore jdtCompilerAdapter \
                                      %{jname}55-runtime 2>&1
build-jar-repository %{commondir}/endorsed jaxp_parser_impl \
                                           xml-commons-apis 2>&1

%post webapps 
# Create automated links - since all needed extensions may not have been
# installed for this jvm output is muted
# Try to set a sensible jvm
export JAVA_HOME=/usr/lib/jdk
export JVM_LIBDIR=/usr/lib/jdk-exports
build-jar-repository %{appdir}/jsp-examples/WEB-INF/lib \
      jakarta-taglibs-core jakarta-taglibs-standard 2>&1

%post admin-webapps
export JAVA_HOME=/usr/lib/jdk
export JVM_LIBDIR=/usr/lib/jdk-exports
# Remove old automated symlinks
find %{serverdir}/webapps/admin/WEB-INF/lib -name '\[*\]*.jar' \
     -not -name 'catalina-admin*' -not -type d | xargs rm -f
build-jar-repository %{serverdir}/webapps/admin/WEB-INF/lib struts 2>&1

%post servlet-%{servletspec}-api
update-alternatives --install %{_javadir}/servlet.jar servlet \
    %{_javadir}/%{name}-servlet-%{servletspec}-api-%{version}.jar 55
update-alternatives --install %{_javadir}/jsp.jar jsp \
    %{_javadir}/%{name}-jsp-%{jspspec}-api-%{version}.jar 55

%post servlet-%{servletspec}-api-javadoc
rm -f %{_javadocdir}/%{name} # legacy symlink
rm -f %{_javadocdir}/jsp-api # legacy symlink
rm -f %{_javadocdir}/%{name}-jsp-%{jspspec}-api
rm -f %{_javadocdir}/%{name}-servlet-%{servletspec}-api
ln -s %{name}-servlet-%{servletspec}-api-%{version} \
    %{_javadocdir}/%{name}-servlet-%{servletspec}-api
ln -s %{name}-jsp-%{jspspec}-api-%{version} \
    %{_javadocdir}/%{name}-jsp-%{jspspec}-api

%postun servlet-%{servletspec}-api
if [ "$1" = "0" ]; then
    update-alternatives --remove servlet \
        %{_javadir}/%{name}-servlet-%{servletspec}-api-%{version}.jar
    update-alternatives --remove jsp \
        %{_javadir}/%{name}-jsp-%{jspspec}-api-%{version}.jar
fi

%preun
# Always clean up workdir and tempdir on upgrade/removal
rm -fr %{workdir}/* %{tempdir}/*
if [ $1 = 0 ]; then
    [ -f /var/lock/subsys/%{name} ] && %{_sysconfdir}/init.d/%{name} stop
    [ -f %{_sysconfdir}/init.d/%{name} ] && /sbin/chkconfig --del %{name}
    # Remove automated symlinks
    for repository in %{serverdir}/lib \
                      %{commondir}/lib \
                      %{commondir}/endorsed ; do
        find $repository -name '\[*\]*.jar' -not -type d | xargs rm -f
    done
fi

%preun admin-webapps
if [ $1 = 0 ]; then
    find %{serverdir}/webapps/admin/WEB-INF/lib  \
         -name '\[*\]*.jar' \
         -not -name 'catalina-admin*' -not -type d | xargs rm -f
fi

%preun webapps
if [ $1 = 0 ]; then
    find %{appdir}/jsp-examples/WEB-INF/lib  \
         -name '\[*\]*.jar' \
         -not -type d | xargs rm -f
fi

%pre
# Add the "tomcat55" user and group
# we need a shell to be able to use su - later
%{_sbindir}/groupadd -g %{tcuid} -r tomcat55 2> /dev/null || :
%{_sbindir}/useradd -c "Tomcat55" -u %{tcuid} -g tomcat55 \
    -s /bin/sh -r -d %{homedir} tomcat55 2> /dev/null || :

%files -f %{packdname}/homelinks
%defattr(644,root,root,755)
%doc %{packdname}/jakarta-tomcat-5/{LICENSE,RELE*,RUNNING.txt,BENCHMARKS.txt}
# Normal directories
%dir %{homedir}
%dir %{bindir}
%dir %{_localstatedir}/lib/%{name}
%dir %{_localstatedir}/cache/%{name}
%dir %{commondir}
%dir %{serverdir}
%dir %{serverdir}/classes
%dir %{serverdir}/lib
%dir %{shareddir}
%dir %{shareddir}/classes
%dir %{shareddir}/lib
%{_javadir}/catalina*.jar
# Directories with special permissions
%attr(770,root,tomcat55) %dir %{appdir}
%attr(775,root,tomcat55) %dir %{confdir}
%attr(775,root,tomcat55) %dir %{tempdir}
%attr(775,root,tomcat55) %dir %{workdir}
%attr(755,tomcat55,tomcat55) %dir %{logdir}
%attr(775,root,tomcat55) %dir %{confdir}/Catalina
%attr(775,root,tomcat55) %dir %{confdir}/Catalina/localhost
%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{bindir}/*
%attr(755,root,root) %{_sysconfdir}/init.d/%{name}
%attr(644,root,tomcat55) %config(noreplace) %{confdir}/catalina.policy
%attr(644,root,tomcat55) %config(noreplace) %{confdir}/catalina.properties
%attr(660,root,tomcat55) %config(noreplace) %{confdir}/jk2.properties
%attr(660,root,tomcat55) %config(noreplace) %{confdir}/tomcat-users.xml
%config(noreplace) %{confdir}/tomcat55.conf
%config(noreplace) %{confdir}/server-minimal.xml
%config(noreplace) %{confdir}/server.xml
%config(noreplace) %{confdir}/web.xml
%config(noreplace) %{confdir}/context.xml
%config(noreplace) %{confdir}/jk2.manifest
%config(noreplace) %{confdir}/jkconf.ant.xml
%config(noreplace) %{confdir}/jkconfig.manifest
%config(noreplace) %{confdir}/shm.manifest
%config(noreplace) %{confdir}/tomcat-jk2.manifest
%config(noreplace) %{confdir}/uriworkermap.properties
%config(noreplace) %{confdir}/workers.properties
%config(noreplace) %{confdir}/workers.properties.minimal
%config(noreplace) %{confdir}/workers2.properties
%config(noreplace) %{confdir}/workers2.properties.minimal
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{commondir}/*
%{serverdir}/lib/*

%files webapps
%defattr(644,root,tomcat55,775)
%dir %{appdir}/servlets-examples
%{appdir}/servlets-examples/*
%dir %{appdir}/jsp-examples
%{appdir}/jsp-examples/*
%dir %{appdir}/ROOT
%{appdir}/ROOT/*
%dir %{appdir}/tomcat-docs
%{appdir}/tomcat-docs/*
%dir %{appdir}/webdav
%{appdir}/webdav/*

%files admin-webapps
%defattr(640,root,tomcat55,750)
%attr(660,root,tomcat55) %{confdir}/Catalina/localhost/manager.xml
%attr(660,root,tomcat55) %{confdir}/Catalina/localhost/host-manager.xml
%{confdir}/Catalina/localhost/admin.xml
%dir %{appdir}/balancer
%{appdir}/balancer/*
%dir %{serverdir}/webapps
%{serverdir}/webapps/*

%files %{jname}
%defattr(644,root,root,755)
%doc $RPM_BUILD_DIR/%{name}-%{version}/%{packdname}/jakarta-tomcat-%{jname}/jasper2/doc/jspc.html
%{_javadir}/%{jname}55-*.jar
%attr(755,root,root) %{_bindir}/%{jname}*.sh
%attr(755,root,root) %{_bindir}/jspc*.sh

%files %{jname}-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{jname}-%{version}
%ghost %doc %{_javadocdir}/%{jname}

%files servlet-%{servletspec}-api
%defattr(-,root,root)
%doc %{packdname}/jakarta-tomcat-5/LICENSE
%{_javadir}/%{name}-servlet-%{servletspec}-api*.jar
%{_javadir}/%{name}-jsp-%{jspspec}-api*.jar

%files servlet-%{servletspec}-api-javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-servlet-%{servletspec}-api-%{version}
%doc %{_javadocdir}/%{name}-jsp-%{jspspec}-api-%{version}
%ghost %doc %{_javadocdir}/%{name}-servlet-%{servletspec}-api
%ghost %doc %{_javadocdir}/%{name}-jsp-%{jspspec}-api

%changelog
* Thu Sep 15 2005 Shiro Yamada <shiro@miraclelinux.com> 0:5.5.9-4jpp.3AX
- update tomcat55.conf

* Mon Sep 12 2005 Shiro Yamada <shiro@miraclelinux.com> 0:5.5.9-4jpp.2AX
- use correct JVM_LIBDIR
- remove jdk dependency

* Thu Sep  8 2005 Shiro Yamada <shiro@miraclelinux.com> 0:5.5.9-4jpp.1AX
- rebuild for Asianux 2.0

* Tue Aug 09 2005 Ralph Apel <r.apel@r-apel.de> 0:5.5.9-4jpp
- Fix reference to geronimo-specs jta
- Buildtime require java-devel >= 1.5.0
- Runtime require java >= 1.4.2
- Drop requires for jaas, jdbc-stdext, jndi, jndi-ldap and jsse
- Drop jaas from server/lib
- Drop jdbc-stdext from common/lib
- Drop jndi from common/lib

* Sat Jul 30 2005 Ralph Apel <r.apel@r-apel.de> 0:5.5.9-3jpp
- Patch jakarta-tomcat-5/build.xml and include sources
  of commons-collections, commons-pool and commons-dbcp
  to build naming-factory-dbcp.jar
- Patch to build jasper-compiler-jdt, now in tomcat55-jasper

* Fri Jul 22 2005 Ralph Apel <r.apel@r-apel.de> 0:5.5.9-2jpp
- Add bin/tomcat-juli.jar to CLASSPATH in catalina.sh if present

* Wed Jul 20 2005 Ralph Apel <r.apel@r-apel.de> 0:5.5.9-1jpp
- Upgrade to 5.5.9
- Rename package to tomcat55
- Rename TOMCAT_USER to tomcat55
- Rename jasper, confs and scripts from suffix 5 to suffix 55

* Fri Feb 04 2005 Jason Corley 0:5.5.7-2jpp
- Add provides servletapi5 in addition to obsoletes servletapi5 (Martin Grotzke)

* Thu Feb 03 2005 Jason Corley 0:5.5.7-1jpp
- Upgrade to current stable release, 5.5.7

* Fri Jan 31 2005 Jason Corley 0:5.5.4-17jpp
- Use new eclipse-ecj package to remove old jasper-compiler-jdt.jar hack

* Thu Jan 27 2005 Jason Corley 0:5.5.4-16jpp
- Attempt to replace non-free jta with free geronimo-specs

* Thu Jan 27 2005 Jason Corley 0:5.5.4-15jpp
- Clean rebuild

* Thu Dec 16 2004 Jason Corley 0:5.5.4-14jpp
- First attempt at jasper subpackages

* Thu Dec 16 2004 Jason Corley 0:5.5.4-13jpp
- Yet another "servletapi" naming scheme change

* Tue Dec 14 2004 Jason Corley 0:5.5.4-12jpp
- Update the servletapi and servletapi-javadoc subpackages to the way proposed
  by Gary Benson (based on work by Ralph Apel) in the 5.0.30 RPMs

* Wed Dec 08 2004 Jason Corley 0:5.5.4-10jpp
- Incorporate Fernando Nasser's javaxssl patch from the tomcat 5.0.28 RPM
- Replace find ... -exec's with find | xargs

* Tue Dec 07 2004 Jason Corley 0:5.5.4-9jpp
- First attempt at the whole servletapi issue
- Replace jmxri references with mx4j
- Build with JDK 1.4 and require a 1.4 JDK to run
- Remove cruft
- Clearly lost track of some stuff between changelog entries ;-)

* Fri Dec 03 2004 Jason Corley 0:5.5.4-1jpp
- First attempt at building 5.5

* Fri Sep 10 2004 Fernando Nasser <fnasser@redhat.com> 0:5.0.27-4jpp
- Rebuild using Tyrex 1.0.1

* Sat Sep 04 2004 Fernando Nasser <fnasser@redhat.com> 0:5.0.27-3jpp
- Rebuild with Ant 1.6.2

* Fri Jul 16 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.27-2jpp
- Oops, don't require mx4j 2.0.1. 1.1.1 or later should be enough.
  jmxri won't work anymore since tc5 needs mx4j-tools.

* Fri Jul 16 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.27-1jpp
- Update to 5.0.27 (stable)
- Don't remove tomcat4 user/group on uninstall see the mailing list
  for discussion
- build w/ xml-apis.jar instead of xmlParserAPIs.jar (release notes 5.0.27)
- Require junit 3.8.1 or newer (release notes 5.0.26)
- Require jakarta-commons-dbcp 1.2.1 or newer (release notes 5.0.27)
- Require jakarta-commons-logging 1.0.4 or newer (release notes 5.0.27)
- Require jakarta-commons-pool 1.1 or newer (release notes 5.0.27)

* Wed Jun 09 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.24-3jpp
- Change default webapps file permissions from 0640 -> 0644

* Tue Jun 08 2004 Fernando Nasser <fnasser@redhat.com> 0:5.0.24-2jpp
- Allow browsing of webapps directory so that JOnAS can build.

* Mon May 17 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.24-1jpp
- Update to 5.0.24
- Require xerces-j2 2.6.2 (release notes 5.0.21), also require ant < 1.6
  as tomcat5 doesn't seem to build cleanly with 1.6 yet.

* Fri Mar 19 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.19-2jpp
- Set JAVA_ENDORSED_DIRS by default in tomcat5.conf, it is otherwise empty
  Suggestion from Aleksander Adamowski <aleksander.adamowski@altkom.pl>  

* Wed Feb 25 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.19-1jpp
- Update to 5.0.19

* Fri Jan 23 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.18-1jpp
- Update to 5.0.18
- Build catalina before connectors
- Hack connectors build
- Require xerces-j2 2.6.0 (release notes 5.0.17)

* Sat Jan 17 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-4jpp
- Create TC4 user and group separately, lets TC5 work out of the box
  on Trustix (Patch from Iain Arnell)

* Sat Jan 10 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-3jpp
- servletapi5 is required
- move confdir/Catalina from admin-webapps to main package
  (otherwise we end up requiring tomcat5-admin-webapps for struts-webapps)

* Sat Jan 10 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-2jpp
- Fix conflict with tomcat4 catalina-ant.jar in %%_javadir by renaming it
  catalina-ant5.jar for now.

* Fri Jan  9 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-1jpp
- First build for JPackage

* Mon Dec 29 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.11
- Merge changes from tomcat4.init to tomcat5.init

* Mon Dec 22 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.10
- Some jsp-examples require jakarta-taglibs-standard to work

* Mon Dec 22 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.9.1
- Struts should be 1.1 or later according to the release notes
- The /admin webapp works now as well
- manager.xml needs to be group writeable, otherwise tomcat complains

* Fri Dec 19 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.7
- Accept an older version of xerces-j2 as well.

* Fri Dec 19 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.6
- Require xerces-j2 instead of just jaxp_parser_impl
- Require jpackage commons-logging instead of internal version

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.5
- Tomcat5 isn't beta anymore

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.beta.4
- Place jspapi, jmxri, commons-el in common/lib as mentioned in the
  upstream RELEASE-NOTES.txt. This makes jsps actually work.

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.beta.3
- Separated jakarta-commons-el from tomcat
- Require servletapi5 and jakata-commons-el
- Added Patch #4 (tomcat5-5.0.16-cluster-pathelement.patch) which fixes
  build failure when servlet-api is renamed something else than the default
- Added Patch #5 (tomcat5-5.0.16-skip-build-on-install.patch) which corrects
  servletapi/jspapi related build snafu on install. They're already built so
  it's OK to skip.

* Thu Dec  4 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.beta.1
- 5.0.16
- jakarta-commons-el included here instead of somewhere else for now,
  packaging unfinished
- Patch #3 removes dependency to jsvc.tar.gz which doesn't seem to be anywhere

* Tue Aug  5 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.12-0.beta.1
- Based on JPackage.org's tomcat4 .spec
- No compat stuff anymore.
- First build

